unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, unitTAuto;

type
  TForm1 = class(TForm)
    ErzeugeButton: TButton;
    ModellLabel: TLabel;
    ModellEdit: TEdit;
    TankenButton: TButton;
    FahrenButton: TButton;
    kmStandLabel: TLabel;
    kmEdit: TEdit;
    TankLabel: TLabel;
    TankTrackBar: TTrackBar;
    Bild: TImage;
    InspektionsLabel: TLabel;
    InspektionsButton: TButton;
    procedure ErzeugeButtonClick(Sender: TObject);
    procedure TankenButtonClick(Sender: TObject);
    procedure FahrenButtonClick(Sender: TObject);
    procedure InspektionsButtonClick(Sender: TObject);
  private
    procedure aktualisiereAnzeige;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

  auto: TAuto;

implementation

{$R *.dfm}

procedure TForm1.ErzeugeButtonClick(Sender: TObject);
var
  modell: string;
  tankvolumen, verbrauch: real;
begin
  if auto <> nil then          // falls bereits ein Autoobjekt erzeugt wurde
    if MessageDlg('Dann wird das bisherige Auto vernichtet!', mtConfirmation, mbOKCancel, 0) = mrOK then
      begin
        auto.Free;
        ModellEdit.Text := '';
        kmEdit.Text := '';
        TankTrackBar.Position := 0;
        Bild.Visible := false;
      end
    else
      exit;
  modell      := InputBox('Erzeugung eines neuen Autos', 'Modellname: ', '');
  tankvolumen := strToFloat(InputBox('', 'Tankvolumen: ', '0'));
  verbrauch   := strToFloat(InputBox('', 'Verbrauch: '  , '0'));
  auto := TAuto.erzeuge(modell, tankvolumen, verbrauch);
  Bild.Visible := true;
  ModellEdit.Text := auto.GibModell;
  aktualisiereAnzeige;
  ActiveControl := TankenButton;
end;

procedure TForm1.TankenButtonClick(Sender: TObject);
begin
  auto.tanke(strToFloat(InputBox('Tanken', 'Menge: ', '0')));
  aktualisiereAnzeige;
end;

procedure TForm1.FahrenButtonClick(Sender: TObject);
begin
  auto.fahre(strToFloat(InputBox('Fahren', 'Entfernung: ', '0')));
  if auto.istInspektionNoetig then
    InspektionsLabel.Visible := true;
  aktualisiereAnzeige;
end;

procedure TForm1.aktualisiereAnzeige;
begin
  kmEdit.Text := intToStr(auto.GibKmstand);

  tankTrackbar.Position := round(auto.GibTankinhalt * 100 / auto.GibTankvolumen);

  case tankTrackbar.Position of
    3..10: TankLabel.Color := clyellow;
    0..2:  TankLabel.Color := clred;
    else   TankLabel.Color := clBtnFace;
  end;

end;

procedure TForm1.InspektionsButtonClick(Sender: TObject);
begin
  auto.macheInspektion;
  InspektionsLabel.Visible := false;
end;

end.
