UNIT unitTAuto;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses Dialogs, SysUtils;

type
  TAuto = class

  private //Attribute
    kmstand : integer;
    naechsteInspektionBeiKM : integer;
    tankinhalt : real;
    tankvolumen : real;
    verbrauch : real;
    modell : string;

  public //Methoden
    constructor erzeuge (modell: string; tankvolumen: real; verbrauch: real); virtual;
    procedure fahre (entfernung: real); virtual;
    procedure macheInspektion; virtual;
    procedure tanke (menge: real); virtual;
    function GibKmstand : integer; virtual;
    function GibModell : string; virtual;
    function gibReichweite : real; virtual;
    function GibTankinhalt : real; virtual;
    function GibTankvolumen : real; virtual;
    function GibVerbrauch : real; virtual;
    function istInspektionNoetig : boolean; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAuto: Methodendefinition 
//+---------------------------------------------------------------------

//-------- erzeuge (public) --------------------------------------------
constructor TAuto.erzeuge (modell: string; tankvolumen: real; verbrauch: real);
begin
  self.modell := modell;
  self.tankvolumen := tankvolumen;
  self.verbrauch := verbrauch;
  kmstand := 0;
  naechsteInspektionBeiKM := 1000;
end;

//-------- fahre (public) ----------------------------------------------
procedure TAuto.fahre (entfernung: real);
begin
  if tankinhalt = 0 then
    showMessage('Der Tank ist leer!')
  else
    if entfernung > gibReichweite then
      showMessage('Wir haben ein Problem ... der Tank reicht nur fr ' + floatToStr(gibReichweite) + ' km !')
    else begin
      kmstand := kmstand + round(entfernung);
      tankinhalt := tankinhalt - entfernung/100*verbrauch;
    end
end;

// Realisierung als Funktion, die Erfolg bzw. Misserfolg zurckliefert:

//-------- macheInspektion (public) ------------------------------------
procedure TAuto.macheInspektion;
begin
  // tue, was auch immer bei der Inspektion gemacht wird, danach:
  naechsteInspektionBeiKM := naechsteInspektionBeiKM + 10000;
end;

//-------- tanke (public) ----------------------------------------------
procedure TAuto.tanke (menge: real);
begin
  tankinhalt := tankinhalt + menge;
  if tankinhalt > tankvolumen then
    showMessage('Leider sind ' + floatToStr(tankinhalt - tankvolumen) + ' Liter bergeflossen...');
end;

//-------- GibKmstand (public) -----------------------------------------
function TAuto.GibKmstand : integer;
begin
  result  := kmstand
end;

//-------- GibModell (public) ------------------------------------------
function TAuto.GibModell : string;
begin
  result := modell
end;

//-------- gibReichweite (public) --------------------------------------
function TAuto.gibReichweite : real;
begin
  result := tankinhalt / verbrauch * 100;
end;

//-------- GibTankinhalt (public) --------------------------------------
function TAuto.GibTankinhalt : real;
begin
  result  := tankinhalt
end;

//-------- GibTankvolumen (public) -------------------------------------
function TAuto.GibTankvolumen : real;
begin
  result  := tankvolumen
end;

//-------- GibVerbrauch (public) ---------------------------------------
function TAuto.GibVerbrauch : real;
begin
  result  := verbrauch
end;

//-------- istInspektionNoetig (public) --------------------------------
function TAuto.istInspektionNoetig : boolean;
begin
  if kmStand > naechsteInspektionBeiKM then
    result := true
  else
    result := false;
end;

end.

