unit Unit1;
// GUI mit zugehrigen Ereignisbehandlungsprozeduren

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  unitTUhrwerk; // eigene Units (mit entsprechenden Klassen)

type
  TForm1 = class(TForm)
    // GUI-Komponenten (vom Formulardesigner automatisch eingetragen!):
    AnzeigeEdit: TEdit;
    ResetButton: TButton;
    StartButton: TButton;
    StoppButton: TButton;
    Timer: TTimer;
    procedure ONCreate(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
    procedure sendeTick(Sender: TObject);

  private
    Uhrwerk: TUhrwerk;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ONCreate(Sender: TObject); // wird beim Programmstart aktiviert,
                                        // d.h. beim Ereignis Form1.OnCreate
begin
  Uhrwerk := TUhrwerk.erzeuge;
  AnzeigeEdit.Text := Uhrwerk.gibZeit;
  ActiveControl := StartButton;
end;

procedure TForm1.StartButtonClick(Sender: TObject);
begin
  Timer.Enabled := true;
  ActiveControl := StoppButton;
end;

procedure TForm1.StopButtonClick(Sender: TObject);
begin
  Timer.Enabled := false;
  ResetButton.Enabled := true;
  StartButton.Caption := 'Weiter';
  ActiveControl := ResetButton;
end;

procedure TForm1.ResetButtonClick(Sender: TObject);
begin
  Uhrwerk.setzeRueck;
  Timer.Enabled := false;
  AnzeigeEdit.Text := Uhrwerk.gibZeit;
  StartButton.Caption := 'Start';
  ActiveControl := StartButton;
end;

procedure TForm1.sendeTick(Sender: TObject);
begin
  Uhrwerk.ticke;
  AnzeigeEdit.Text := Uhrwerk.gibZeit;
end;

end.
