UNIT mTStoppuhr;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mTZaehler,
     ExtCtrls, // fr TTimer
     StdCtrls; // fr TEdit

type
  TStoppuhr = class

  private //Attribute
    Hundertstel : TZaehler;
    Sekunden : TZaehler;
    Taktgeber: TTimer;
    Anzeige: TEdit;
    istLaufend: boolean;

  public //Methoden
    constructor erzeugen(AnzeigeFeld: TEdit); virtual;
    procedure erhoehen; virtual;
    procedure starten; virtual;
    procedure stoppen; virtual;
    procedure zuruecksetzen; virtual;
    function gibAnzeige : string; virtual;
    procedure ticke(Sender: TObject); // Ereignisbehandlungsprozedur fr den Timer!
   end;

implementation

//+---------------------------------------------------------------------
//|         TStoppuhr: Methodendefinition 
//+---------------------------------------------------------------------

//-------- erzeugen (public) -------------------------------------------
constructor TStoppuhr.erzeugen(AnzeigeFeld: TEdit);
begin
  Sekunden    := TZaehler.erzeugen(60);
  Hundertstel := TZaehler.erzeugen(100);
  Taktgeber   := TTimer.Create(nil); // nil als Eigentmer des Timers!
  Anzeige     := AnzeigeFeld;  // wird von der GUI-Klasse geliefert!
  Taktgeber.Interval := 10;
  Taktgeber.Enabled := false;
  Taktgeber.OnTimer := ticke;  // "ticke" als Ereignisbehandlungsprozedur-Name
end;

//-------- ticke (public) -------------------------------------------
procedure TStoppuhr.ticke(Sender: TObject); // Sender sinnlos, aber syntaktisch ntig!
begin
  erhoehen;
end;

//-------- erhoehen (public) -------------------------------------------
procedure TStoppuhr.erhoehen;
begin
  Hundertstel.erhoehen;
  if Hundertstel.GibWert = 0 then
    Sekunden.erhoehen;
  Anzeige.Text := self.gibAnzeige;
end;

//-------- starten (public) --------------------------------------------
procedure TStoppuhr.starten;
begin
  Taktgeber.Enabled := true;

  { alternativ mit sleep-Schleife (krzeres Timing) statt Timer (min. 20ms):
  istLaufend := true;
  repeat
    erhoehen;
    sleep(1);
  until istLaufend = false; // muss von der Methode "stoppen" gesetzt werden
  }

end;

//-------- stoppen (public) --------------------------------------------
procedure TStoppuhr.stoppen;
begin
  Taktgeber.Enabled := false;
end;

//-------- zuruecksetzen (public) --------------------------------------
procedure TStoppuhr.zuruecksetzen;
begin
  Sekunden.zuruecksetzen;
  Hundertstel.zuruecksetzen;
  Anzeige.Text := self.gibAnzeige;
end;

//-------- gibAnzeige (public) -----------------------------------------
function TStoppuhr.gibAnzeige : string;
begin
  result := Sekunden.gibString + ':' + Hundertstel.gibString;
end;

end.
