UNIT unitTStoppuhr;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses unitTZaehler, SysUtils;

type
  TStoppuhr = class

  private //Attribute
    hundertstel : TZaehler;
    sekunden : TZaehler;

  public //Methoden
    constructor erzeuge; virtual;
    procedure setzeRueck; virtual;
    procedure ticke; // nicht berschreibbar
    function gibZeit : string; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TStoppuhr: Methodendefinition 
//+---------------------------------------------------------------------

//-------- erzeuge (public) --------------------------------------------
constructor TStoppuhr.erzeuge;
begin
  Sekunden       := TZaehler.erzeuge(60);
  Hundertstel    := TZaehler.erzeuge(100);
end;

//-------- setzeRueck (public) -----------------------------------------
procedure TStoppuhr.setzeRueck;
begin
  Sekunden.setzeWert(0);
  Hundertstel.setzeWert(0);
end;

//-------- ticke (public) ----------------------------------------------
procedure TStoppuhr.ticke;
begin
  Hundertstel.erhoehe;
  if Hundertstel.GibWert = 0 then
    Sekunden.erhoehe;
end;

//-------- gibZeit (public) --------------------------------------------
function TStoppuhr.gibZeit : string;
begin
  //result := Sekunden.gibString + ':' + Hundertstel.gibString;
  result := FormatFloat('00',Sekunden.gibWert) + ':' + FormatFloat('00',Hundertstel.gibWert);
end;

end.
